Loading...
Searching...
No Matches
gtsam::NonlinearConjugateGradientOptimizer Class Reference

## Detailed Description

An implementation of the nonlinear CG method using the template below.

Inheritance diagram for gtsam::NonlinearConjugateGradientOptimizer:

## Public Member Functions

| NonlinearConjugateGradientOptimizer (const NonlinearFactorGraph &graph, const Values &initialValues, const Parameters &params=Parameters())
| Constructor.
| ~NonlinearConjugateGradientOptimizer () override
| Destructor.
GaussianFactorGraph::shared_ptr | iterate () override
| Perform a single iteration, returning GaussianFactorGraph corresponding to the linearized factor graph.
const Values & | optimize () override
| Optimize for the maximum-likelihood estimate, returning a the optimized variable assignments.
Public Member Functions inherited from gtsam::NonlinearOptimizer
const Values & | optimizeSafely ()
| Optimize, but return empty result if any uncaught exception is thrown Intended for MATLAB.
double | error () const
| return error in current optimizer state
size_t | iterations () const
| return number of iterations in current optimizer state
const Values & | values () const
| return values in current optimizer state
const NonlinearFactorGraph & | graph () const
| return the graph with nonlinear factors
virtual | ~NonlinearOptimizer ()
| Virtual destructor.
virtual VectorValues | solve (const GaussianFactorGraph &gfg, const NonlinearOptimizerParams &params) const
| Default function to do linear solve, i.e.

## Public Types

typedef NonlinearOptimizer | Base
typedef NonlinearOptimizerParams | Parameters
typedef boost::shared_ptr< NonlinearConjugateGradientOptimizer > | shared_ptr
Public Types inherited from gtsam::NonlinearOptimizer
using | shared_ptr = boost::shared_ptr<const NonlinearOptimizer>
| A shared pointer to this class.

## Protected Member Functions

const NonlinearOptimizerParams & | _params () const override
Protected Member Functions inherited from gtsam::NonlinearOptimizer
void | defaultOptimize ()
| A default implementation of the optimization loop, which calls iterate() until checkConvergence returns true.
| NonlinearOptimizer (const NonlinearFactorGraph &graph, std::unique_ptr< internal::NonlinearOptimizerState > state)
| Constructor for initial construction of base classes.

## Protected Attributes

Parameters | params_
Protected Attributes inherited from gtsam::NonlinearOptimizer
NonlinearFactorGraph | graph_
| The graph with nonlinear factors.
std::unique_ptr< internal::NonlinearOptimizerState > | state_
| PIMPL'd state.

## Member Function Documentation

## _params()

const NonlinearOptimizerParams & gtsam::NonlinearConjugateGradientOptimizer::_params | ( |  | ) | const

inline override protected virtual

Implements gtsam::NonlinearOptimizer.

## iterate()

GaussianFactorGraph::shared_ptr gtsam::NonlinearConjugateGradientOptimizer::iterate | ( | void |  | ) |

override virtual

Perform a single iteration, returning GaussianFactorGraph corresponding to the linearized factor graph.

Implements gtsam::NonlinearOptimizer.

## optimize()

const Values & gtsam::NonlinearConjugateGradientOptimizer::optimize | ( |  | ) |

override virtual

Optimize for the maximum-likelihood estimate, returning a the optimized variable assignments.

Reimplemented from gtsam::NonlinearOptimizer.

The documentation for this class was generated from the following files:

- /build/gtsam-RkN8wG/gtsam-4.2.2+dfsg/gtsam/nonlinear/NonlinearConjugateGradientOptimizer.h
- /build/gtsam-RkN8wG/gtsam-4.2.2+dfsg/gtsam/nonlinear/NonlinearConjugateGradientOptimizer.cpp